/*
 * Field.h
 *
 *  Created on: Dec 4, 2011
 *      Author: janez
 */

#ifndef FIELD_H_
#define FIELD_H_

#include "Vector.h"
#include "Particle.h"

class Field {
	int type;
	double angle_xy;
	double angle_yz;
	double abs_value;

	Vector3 force_B_axis_Y( int direction, Particle *pt );
	Vector3 force_B_axis_Z( int direction, Particle *pt );

public:
	static const int FIELD_ELECTRIC = 1;
	static const int FIELD_TYPE_E = 1;
	static const int FIELD_MAGNETIC = 2;
	static const int FIELD_TYPE_B = 2;
    Field();
	virtual ~Field();
	void init();

	inline 	double getAbs_value() { return abs_value; }
	inline double getAngle_yz() { return angle_yz; }
	inline double getAngle_xy() { return angle_xy; }
	inline int getType() { return type; }
	inline void setAbs_value(double abs_value) { this->abs_value = abs_value; }
	inline void setAngle_yz(double angle_yz) { this->angle_yz = angle_yz; }
	inline void setAngle_xy(double angle_xy) { this->angle_xy = angle_xy; }
	inline void setType(int type) { this->type = type; }

	Vector3 computeForce( Particle *part );

};

#endif /* FIELD_H_ */
