/*
 * Grid.h
 *
 *  Created on: Aug 18, 2011
 *      Author: janez
 */

#ifndef GRID_H_
#define GRID_H_

#include "peg_tc.h"
#include "Vector.h"

class Grid {
	Vector3 r0, r1;		// coordinates: 0-start, 1-end in each direction (x,y,z)
	long int n[3];		// number of cells in each directions 0=x, 1=y, 2=z

public:
	Grid();
	virtual ~Grid();
	void init();

	inline void set_r0( Vector3 in_r ) { r0 = in_r; };
	inline void set_r1( Vector3 in_r ) { r1 = in_r; };
	inline void set_nx( long int in_n) { n[0] = in_n; };
	inline void set_ny( long int in_n) { n[1] = in_n; };
	inline void set_nz( long int in_n) { n[2] = in_n; };
	inline void set_n( long int in_nx, long int in_ny, long int in_nz) { n[0] = in_nx; n[1] = in_ny; n[2] = in_nz; };
	inline void set_n( long int in_n[3] ) { n[0] = in_n[0]; n[1] = in_n[1]; n[2] = in_n[2]; };
	inline void set_n( int i, long int in_n) { if(i < 3) { n[i] = in_n; }; };

	inline Vector3 get_r0() { return r0; };
	inline Vector3 get_r1() { return r1; };
	inline long int get_n(int i) { return (i < 3) ? n[i] : 0; };
	inline long int get_nx() { return n[0]; };
	inline long int get_ny() { return n[1]; };
	inline long int get_nz() { return n[2]; };
	double get_x( int i, long int i_cell );
	int get_cell( int i_dir, double x );


	void dump(int level);
	bool defined(bool dispErrors);
};

#endif /* GRID_H_ */
