/*
 * Particle.h
 *
 *  Created on: Aug 5, 2011
 *      Author: janez
 */

#ifndef PARTICLE_H_
#define PARTICLE_H_

#include "peg_tc.h"

#include "Vector.h"
#include <string>

class Particle {
	Vector3 r;
	Vector3 v;
	Vector3 f;
	double q, m;
	char sp_index;


public:
	Particle();
	virtual ~Particle();
	void init();

    // define methods for setting and getting particle data
    inline double get_q() {return q;};
    inline double get_m() {return m;};
    inline Vector3 get_r() {return r;};
    inline Vector3 get_v() {return v;};
    inline Vector3 get_f() {return f;};
    inline int get_sp_index() {return (int) sp_index;};

    std::string get_str_r();
    std::string get_str_rx();
    std::string get_str_v();
    std::string get_str_f();

    inline void set_q(double in_q) {	q = in_q; };
    inline void set_m(double in_m) {	m = in_m; };
    inline void set_r(Vector3 in_r) { r = in_r; };
    inline void set_r(double rx, double ry, double rz) { r.set( rx, ry, rz ); };
    inline void set_v(Vector3 in_v) { v = in_v; };
    inline void set_v(double vx, double vy, double vz) { v.set( vx, vy, vz ); };
    inline void set_f(Vector3 in_f) { f = in_f; };
    inline void set_f(double fx, double fy, double fz) { f.set( fx, fy, fz ); };
    inline void set_sp_index(int in_sp_index) { sp_index = (char) in_sp_index; };

};

#endif /* PARTICLE_H_ */
