/*
 * ParticleList.cpp
 *
 *  Created on: Aug 10, 2011
 *      Author: janez
 */

#include "ParticleList.h"
#include <iostream>
using namespace std;

ParticleList::ParticleList() {
	init();
}

ParticleList::~ParticleList() {

}


/**
 * Operator to add particles in given list to particles in current list
 */
ParticleList& ParticleList::operator += (ParticleList pl) {
	long int i;

	for( i = 0 ; i < pl.size() ; i++ ) {
		// add given particles to current particle list
		particles.push_back( pl[i] );
	}

	return *this;
}


/**
 * Operator to add given to particle list.
 * @param pt -- particle to add
 */
ParticleList& ParticleList::operator += (Particle pt) {
	particles.push_back( pt );

	return *this;
}


/**
 * Get particle. Returns "empty" particle in case position is out of range.
 * @param pos -- position of particle to return
 * @return -- returns particle or empty one in case pos is wrong
 */
Particle ParticleList::operator [] (unsigned long int pos) {

	if( pos < particles.size( ) && pos >= 0 ) {
		// return particle
		return particles[pos];
	} else {
		// error
		Particle pt;
		cout << "[ParticleList] accessing position beyond list size: pos=" << pos << ", size=" << particles.size() << endl;
		return pt;
	}
}


/**
 * Delete particles with indexes in given array.
 */
void ParticleList::deleteParticles(std::vector<unsigned int> list) {
	unsigned int i;


	//
	// this is very bad and slow, but for time being it is OK -- as long as it works!
	//

	for( i=0 ; i < list.size() ; i++ ) {
		// delete particles from current list
		particles.erase( particles.begin() + list[i] - i ) ;
	}
}


/*
 * Dump current particles.
 */
void ParticleList::dump(int level){
	string offset = "";

	for( int i=0 ; i < level ; i++ ) {
		offset += "  ";
	}

	cout << endl << offset << "Particle list, " << particles.size() << " particle(s):" << endl;

	for( unsigned int i=0 ; i < particles.size() ; i++ ) {
		// all particles...
		cout << offset << "  " << i << ". ";
		cout << "r=(" << particles[i].get_r().e1() << ", " << particles[i].get_r().e2() << ", " << particles[i].get_r().e3() << "), ";
		cout << "v=(" << particles[i].get_v().e1() << ", " << particles[i].get_v().e2() << ", " << particles[i].get_v().e3() << ")" << endl;
	}
}
