/*
 * Mover.cpp
 *
 *  Created on: Aug 11, 2011
 *      Author: janez
 */

#include "ParticleMover.h"

ParticleMover::ParticleMover() {

}

ParticleMover::~ParticleMover() {
}


/**
 * Movie particles in given particle list.
 */
void ParticleMover::move( ParticleList& pl, SpatialRegion& region, double t, double dt, long int n ) {
	long int i;
	Particle *pt;
	Vector3 r, v;


	for( i=0 ; i < pl.size() ; i++ ) {
		// move all particles
		pt = pl.getParticle(i);
		// current particle position and velocity;
		r = pt->get_r();
		v = pt->get_v();
		// move particle to new location (location at n) and save it
		r = r + dt*v;
		pt->set_r(r);
		// compute new velocity (velocity at n+1/2)
		v = v + dt*pt->get_f()/pt->get_m();
		pt->set_v(v);
	}
}

